#! /bin/sh
rm -f thermal_out.dat
rm -f cascade_out.dat
rm -f temp_data/*.dat
rm -f results/*.dat

cp -f parameters.h source_codes/parameters.h
cp -f parameters.h results/parameters.h
cd source_codes

make scatinit
make scatsummer
make thermal
make headerwrite
make cascade
make binner

echo PROGRAMS COMPILED
cd ..
source_codes/scatinit
source_codes/headerwrite

i=0
nevents=$1
echo nevents=$nevents
while [ ${i} -lt ${nevents} ]; 
do
	i=`expr ${i} + 1`
	echo BEGIN EVENT \#${i}
	echo "1" | source_codes/thermal >> thermal_out.dat
	echo -------------- FINISHED BURN FOR EVENT  $i -------------------- 
	mv -f temp_data/scatvstime.dat temp_data/oldscatvstime.dat
	echo ${i} | source_codes/cascade >> cascade_out.dat
	echo -------------- FINISHED CRASH FOR EVENT $i -------------------- 
	rm -f explode.dat
	source_codes/scatsummer
	mv -f temp_data/tempscatvstime.dat temp_data/scatvstime.dat
done

mv -f temp_data/scatvstime.dat results
rm -f temp_data/*.dat

echo                      ++++++++++++++++++++++++++ 
echo $1 | source_codes/binner >> results/binner_results.dat
cat results/binner_results.dat
