/* CONTROL parameters that affect physics */
/*#define NOEVAPORATE*/         /* turns off evaporation in "thermal" */
/*#define NOCOLLISIONS*/        /* no collisions in "cascade", turns on Bose
				   effects in "thermal" */
/*#define TURN_OFF_COLLS_AFTER*//* For no collisions after "max_coll_tau" */

/* Parameters used by Evaporate */
#define rapmax 1.62      /* Max rapidity of thermal sources */
#define vxmax 0.305       /* Max transverse velocity */
#define xinitsize 6.0    /* transverse size at t=0 */
#define temp 160.0       /* temperature */
#define taumax 6.91      /* dissolution time */
#define mub 190          /* Baryon chem. pot. */
#define mus 0.0          /* Strangeness chem. pot. */
#define fugacity 1.0     /* Enhancement factor, =1 for chem. eq. */
#define iseed -12345     /* Random no. generator seed, should be < 0 */

/* Parameters used by Cascade */
/*#define max_coll_tau 50.0*/   /* Only used if TURN_OFF_COLLS_AFTER defined */
#define sigma_elastic_scale 1.0 /* The scaling factor for cross-sections
				   which are 15 mb for meson-meson, 20 mb
				   for meson-nucleon and 25 mb for NN. */
#define tau_order  /* Order collisions by Bjorken tau
		      Collisions ordered by time otherwise */
  
/* Other parameters which don't change results but may be necessary to
   adjust (e.g. array sizes) can be found in either "thermal_main.c" or
   "cascade.c" */
